diff --git a/gcc/combine.c b/gcc/combine.c
index fc473b6..24be315 100644
--- a/gcc/combine.c
+++ b/gcc/combine.c
@@ -2481,7 +2481,7 @@ try_combine (rtx i3, rtx i2, rtx i1, rtx i0, int *new_direct_jump_p,
       int ngood = 0;
       int nshift = 0;
 
-      if (!flag_expensive_optimizations)
+      if (!GCC_OPTION (flag_expensive_optimizations))
 	return 0;
 
       for (i = 0; i < 4; i++)
@@ -3040,7 +3040,7 @@ try_combine (rtx i3, rtx i2, rtx i1, rtx i0, int *new_direct_jump_p,
 	 unmodified I2PAT is used in the PARALLEL and so a pattern
 	 with a modified I2SRC would not match.  */
 
-      if (flag_expensive_optimizations)
+      if (GCC_OPTION (flag_expensive_optimizations))
 	{
 	  /* Pass pc_rtx so no substitutions are done, just
 	     simplifications.  */
@@ -3547,7 +3547,7 @@ try_combine (rtx i3, rtx i2, rtx i1, rtx i0, int *new_direct_jump_p,
 		       && GET_CODE (XEXP (src_op0, 0)) == code
 		       && (INTEGRAL_MODE_P (mode)
 			   || (FLOAT_MODE_P (mode)
-			       && flag_unsafe_math_optimizations)))
+			       && GCC_OPTION (flag_unsafe_math_optimizations))))
 		{
 		  rtx p = XEXP (XEXP (src_op0, 0), 0);
 		  rtx q = XEXP (XEXP (src_op0, 0), 1);
@@ -5374,7 +5374,7 @@ combine_simplify_rtx (rtx x, enum machine_mode op0_mode, int in_dest,
        || code == AND || code == IOR || code == XOR
        || code == SMAX || code == SMIN || code == UMAX || code == UMIN)
       && ((INTEGRAL_MODE_P (mode) && code != DIV)
-	  || (flag_associative_math && FLOAT_MODE_P (mode))))
+	  || (GCC_OPTION (flag_associative_math) && FLOAT_MODE_P (mode))))
     {
       if (GET_CODE (XEXP (x, 0)) == code)
 	{
@@ -5648,7 +5648,7 @@ combine_simplify_rtx (rtx x, enum machine_mode op0_mode, int in_dest,
 	}
 
       /* Try simplify a*(b/c) as (a*b)/c.  */
-      if (FLOAT_MODE_P (mode) && flag_associative_math
+      if (FLOAT_MODE_P (mode) && GCC_OPTION (flag_associative_math)
 	  && GET_CODE (XEXP (x, 0)) == DIV)
 	{
 	  rtx tem = simplify_binary_operation (MULT, mode,
@@ -6056,7 +6056,7 @@ simplify_if_then_else (rtx x)
 
   /* Look for MIN or MAX.  */
 
-  if ((! FLOAT_MODE_P (mode) || flag_unsafe_math_optimizations)
+  if ((! FLOAT_MODE_P (mode) || GCC_OPTION (flag_unsafe_math_optimizations))
       && comparison_p
       && rtx_equal_p (XEXP (cond, 0), true_rtx)
       && rtx_equal_p (XEXP (cond, 1), false_rtx)
@@ -7188,7 +7188,7 @@ make_extraction (enum machine_mode mode, rtx inner, HOST_WIDE_INT pos,
       /* If we know that no extraneous bits are set, and that the high
 	 bit is not set, convert the extraction to the cheaper of
 	 sign and zero extension, that are equivalent in these cases.  */
-      if (flag_expensive_optimizations
+      if (GCC_OPTION (flag_expensive_optimizations)
 	  && (HWI_COMPUTABLE_MODE_P (tmode)
 	      && ((nonzero_bits (new_rtx, tmode)
 		   & ~(((unsigned HOST_WIDE_INT)GET_MODE_MASK (tmode)) >> 1))
@@ -7372,7 +7372,7 @@ make_extraction (enum machine_mode mode, rtx inner, HOST_WIDE_INT pos,
 	 bit is not set, convert extraction to cheaper one - either
 	 SIGN_EXTENSION or ZERO_EXTENSION, that are equivalent in these
 	 cases.  */
-      if (flag_expensive_optimizations
+      if (GCC_OPTION (flag_expensive_optimizations)
 	  && (HWI_COMPUTABLE_MODE_P (GET_MODE (pos_rtx))
 	      && ((nonzero_bits (pos_rtx, GET_MODE (pos_rtx))
 		   & ~(((unsigned HOST_WIDE_INT)
@@ -9137,7 +9137,7 @@ apply_distributive_law (rtx x)
   /* Distributivity is not true for floating point as it can change the
      value.  So we don't do it unless -funsafe-math-optimizations.  */
   if (FLOAT_MODE_P (GET_MODE (x))
-      && ! flag_unsafe_math_optimizations)
+      && ! GCC_OPTION (flag_unsafe_math_optimizations))
     return x;
 
   /* The outer operation can only be one of the following:  */
@@ -9266,7 +9266,7 @@ distribute_and_simplify_rtx (rtx x, int n)
   /* Distributivity is not true for floating point as it can change the
      value.  So we don't do it unless -funsafe-math-optimizations.  */
   if (FLOAT_MODE_P (GET_MODE (x))
-      && ! flag_unsafe_math_optimizations)
+      && ! GCC_OPTION (flag_unsafe_math_optimizations))
     return NULL_RTX;
 
   decomposed = XEXP (x, n);
@@ -13856,7 +13856,7 @@ dump_combine_total_stats (FILE *file)
 static bool
 gate_handle_combine (void)
 {
-  return (optimize > 0);
+  return (GCC_OPTION (optimize) > 0);
 }
 
 /* Try combining insns through substitution.  */
diff --git a/gcc/common/config/arc/arc-common.c b/gcc/common/config/arc/arc-common.c
index 0398680..07105f8 100644
--- a/gcc/common/config/arc/arc-common.c
+++ b/gcc/common/config/arc/arc-common.c
@@ -34,7 +34,7 @@ arc_option_init_struct (struct gcc_options *opts)
   opts->x_flag_no_common = 255; /* Mark as not user-initialized.  */
 
   /* Which cpu we're compiling for (A5, ARC600, ARC601, ARC700).  */
-  arc_cpu = PROCESSOR_NONE;
+  GCC_OPTION (arc_cpu) = PROCESSOR_NONE;
 }
 
 /* Set default optimization options.  */
diff --git a/gcc/compare-elim.c b/gcc/compare-elim.c
index 3fbe140..ada88b8 100644
--- a/gcc/compare-elim.c
+++ b/gcc/compare-elim.c
@@ -649,7 +649,7 @@ gate_compare_elim_after_reload (void)
   /* Setting this target hook value is how a backend indicates the need.  */
   if (targetm.flags_regnum == INVALID_REGNUM)
     return false;
-  return flag_compare_elim_after_reload;
+  return GCC_OPTION (flag_compare_elim_after_reload);
 }
 
 namespace {
diff --git a/gcc/config/aarch64/aarch64.c b/gcc/config/aarch64/aarch64.c
index ebd58c0..170d9bb 100644
--- a/gcc/config/aarch64/aarch64.c
+++ b/gcc/config/aarch64/aarch64.c
@@ -999,7 +999,7 @@ aarch64_expand_mov_immediate (rtx dest, rtx imm)
   /* Remaining cases are all for DImode.  */
 
   val = INTVAL (imm);
-  subtargets = optimize && can_create_pseudo_p ();
+  subtargets = GCC_OPTION (optimize) && can_create_pseudo_p ();
 
   one_match = 0;
   zero_match = 0;
@@ -1700,9 +1700,9 @@ aarch64_frame_pointer_required (void)
      If we really did set flag_omit_frame_pointer normally, then we return false
      (no frame pointer required) in all cases.  */
 
-  if (flag_omit_frame_pointer && !faked_omit_frame_pointer)
+  if (GCC_OPTION (flag_omit_frame_pointer) && !faked_omit_frame_pointer)
     return false;
-  else if (flag_omit_leaf_frame_pointer)
+  else if (GCC_OPTION (flag_omit_leaf_frame_pointer))
     return !crtl->is_leaf || df_regs_ever_live_p (LR_REGNUM);
   return true;
 }
@@ -2051,7 +2051,7 @@ aarch64_expand_prologue (void)
   offset = frame_size = AARCH64_ROUND_UP (frame_size,
 					  STACK_BOUNDARY / BITS_PER_UNIT);
 
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     current_function_static_stack_size = frame_size;
 
   fp_offset = (offset
@@ -4985,7 +4985,7 @@ aarch64_add_stmt_cost (void *data, int count, enum vect_cost_for_stmt kind,
   unsigned *cost = (unsigned *) data;
   unsigned retval = 0;
 
-  if (flag_vect_cost_model)
+  if (GCC_OPTION (flag_vect_cost_model))
     {
       tree vectype = stmt_info ? stmt_vectype (stmt_info) : NULL_TREE;
       int stmt_cost =
@@ -5085,10 +5085,10 @@ aarch64_parse_arch (void)
 {
   char *ext;
   const struct processor *arch;
-  char *str = (char *) alloca (strlen (aarch64_arch_string) + 1);
+  char *str = (char *) alloca (strlen (GCC_OPTION (aarch64_arch_string)) + 1);
   size_t len;
 
-  strcpy (str, aarch64_arch_string);
+  strcpy (str, GCC_OPTION (aarch64_arch_string));
 
   ext = strchr (str, '+');
 
@@ -5142,10 +5142,10 @@ aarch64_parse_cpu (void)
 {
   char *ext;
   const struct processor *cpu;
-  char *str = (char *) alloca (strlen (aarch64_cpu_string) + 1);
+  char *str = (char *) alloca (strlen (GCC_OPTION (aarch64_cpu_string)) + 1);
   size_t len;
 
-  strcpy (str, aarch64_cpu_string);
+  strcpy (str, GCC_OPTION (aarch64_cpu_string));
 
   ext = strchr (str, '+');
 
@@ -5190,8 +5190,8 @@ static void
 aarch64_parse_tune (void)
 {
   const struct processor *cpu;
-  char *str = (char *) alloca (strlen (aarch64_tune_string) + 1);
-  strcpy (str, aarch64_tune_string);
+  char *str = (char *) alloca (strlen (GCC_OPTION (aarch64_tune_string)) + 1);
+  strcpy (str, GCC_OPTION (aarch64_tune_string));
 
   /* Loop through the list of supported CPUs to find a match.  */
   for (cpu = all_cores; cpu->name != NULL; cpu++)
@@ -5221,17 +5221,17 @@ aarch64_override_options (void)
      So, first parse AARCH64_CPU_STRING, then the others, be careful
      with -march as, if -mcpu is not present on the command line, march
      must set a sensible default CPU.  */
-  if (aarch64_cpu_string)
+  if (GCC_OPTION (aarch64_cpu_string))
     {
       aarch64_parse_cpu ();
     }
 
-  if (aarch64_arch_string)
+  if (GCC_OPTION (aarch64_arch_string))
     {
       aarch64_parse_arch ();
     }
 
-  if (aarch64_tune_string)
+  if (GCC_OPTION (aarch64_tune_string))
     {
       aarch64_parse_tune ();
     }
@@ -5248,8 +5248,8 @@ aarch64_override_options (void)
   aarch64_build_bitmask_table ();
 
   /* This target defaults to strict volatile bitfields.  */
-  if (flag_strict_volatile_bitfields < 0 && abi_version_at_least (2))
-    flag_strict_volatile_bitfields = 1;
+  if (GCC_OPTION (flag_strict_volatile_bitfields) < 0 && abi_version_at_least (2))
+    GCC_OPTION (flag_strict_volatile_bitfields) = 1;
 
   /* If the user did not specify a processor, choose the default
      one for them.  This will be the CPU set during configuration using
@@ -5284,9 +5284,9 @@ aarch64_override_options_after_change (void)
      that aarch64_frame_pointer_required will be called.  We need to remember
      whether flag_omit_frame_pointer was turned on normally or just faked.  */
 
-  if (flag_omit_leaf_frame_pointer && !flag_omit_frame_pointer)
+  if (GCC_OPTION (flag_omit_leaf_frame_pointer) && !GCC_OPTION (flag_omit_frame_pointer))
     {
-      flag_omit_frame_pointer = true;
+      GCC_OPTION (flag_omit_frame_pointer) = true;
       faked_omit_frame_pointer = true;
     }
 }
@@ -5309,9 +5309,9 @@ aarch64_init_expanders (void)
 static void
 initialize_aarch64_code_model (void)
 {
-   if (flag_pic)
+   if (GCC_OPTION (flag_pic))
      {
-       switch (aarch64_cmodel_var)
+       switch (GCC_OPTION (aarch64_cmodel_var))
 	 {
 	 case AARCH64_CMODEL_TINY:
 	   aarch64_cmodel = AARCH64_CMODEL_TINY_PIC;
@@ -5321,13 +5321,13 @@ initialize_aarch64_code_model (void)
 	   break;
 	 case AARCH64_CMODEL_LARGE:
 	   sorry ("code model %qs with -f%s", "large",
-		  flag_pic > 1 ? "PIC" : "pic");
+		  GCC_OPTION (flag_pic) > 1 ? "PIC" : "pic");
 	 default:
 	   gcc_unreachable ();
 	 }
      }
    else
-     aarch64_cmodel = aarch64_cmodel_var;
+     aarch64_cmodel = GCC_OPTION (aarch64_cmodel_var);
 }
 
 /* Return true if SYMBOL_REF X binds locally.  */
@@ -6202,7 +6202,7 @@ aapcs_vfp_sub_candidate (const_tree type, enum machine_mode *modep)
 static bool
 aarch64_lra_p (void)
 {
-  return aarch64_lra_flag;
+  return GCC_OPTION (aarch64_lra_flag);
 }
 
 /* Return TRUE if the type, as described by TYPE and MODE, is a composite
@@ -8500,7 +8500,7 @@ aarch64_cannot_change_mode_class (enum machine_mode from,
 #undef TARGET_VECTORIZE_PREFERRED_SIMD_MODE
 #define TARGET_VECTORIZE_PREFERRED_SIMD_MODE aarch64_preferred_simd_mode
 
-#undef TARGET_VECTORIZE_BUILTINS
+#undef GCC_OPTION (TARGET_VECTORIZE_BUILTINS)
 #define TARGET_VECTORIZE_BUILTINS
 
 #undef TARGET_VECTORIZE_BUILTIN_VECTORIZED_FUNCTION
diff --git a/gcc/config/aarch64/aarch64.h b/gcc/config/aarch64/aarch64.h
index 7962aa4..9a67f52 100644
--- a/gcc/config/aarch64/aarch64.h
+++ b/gcc/config/aarch64/aarch64.h
@@ -127,7 +127,7 @@
    faster.  */
 #define CONSTANT_ALIGNMENT(EXP, ALIGN)		\
   ((TREE_CODE (EXP) == STRING_CST		\
-    && !optimize_size				\
+    && !GCC_OPTION (optimize_size)				\
     && (ALIGN) < BITS_PER_WORD)			\
    ? BITS_PER_WORD : ALIGN)
 
@@ -547,7 +547,7 @@ enum aarch64_abi_type
 #define AARCH64_ABI_DEFAULT AARCH64_ABI_LP64
 #endif
 
-#define TARGET_ILP32	(aarch64_abi & AARCH64_ABI_ILP32)
+#define TARGET_ILP32	(GCC_OPTION (aarch64_abi) & AARCH64_ABI_ILP32)
 
 enum arm_pcs
 {
@@ -833,7 +833,7 @@ do {									     \
 		(FP_REGNUM_P (REGNO) && GET_MODE_SIZE (MODE) > 8)
 
 /* Check TLS Descriptors mechanism is selected.  */
-#define TARGET_TLS_DESC (aarch64_tls_dialect == TLS_DESCRIPTORS)
+#define TARGET_TLS_DESC (GCC_OPTION (aarch64_tls_dialect) == TLS_DESCRIPTORS)
 
 extern enum aarch64_code_model aarch64_cmodel;
 
diff --git a/gcc/config/alpha/alpha.c b/gcc/config/alpha/alpha.c
index df4cc1b..a0479d0 100644
--- a/gcc/config/alpha/alpha.c
+++ b/gcc/config/alpha/alpha.c
@@ -282,13 +282,13 @@ alpha_option_override (void)
   /* Default to full IEEE compliance mode for Go language.  */
   if (strcmp (lang_hooks.name, "GNU Go") == 0
       && !(target_flags_explicit & MASK_IEEE))
-    target_flags |= MASK_IEEE;
+    GCC_OPTION (target_flags) |= MASK_IEEE;
 
   alpha_fprm = ALPHA_FPRM_NORM;
   alpha_tp = ALPHA_TP_PROG;
   alpha_fptm = ALPHA_FPTM_N;
 
-  if (TARGET_IEEE)
+  if (GCC_OPTION (TARGET_IEEE))
     {
       alpha_tp = ALPHA_TP_INSN;
       alpha_fptm = ALPHA_FPTM_SU;
@@ -299,68 +299,68 @@ alpha_option_override (void)
       alpha_fptm = ALPHA_FPTM_SUI;
     }
 
-  if (alpha_tp_string)
+  if (GCC_OPTION (alpha_tp_string))
     {
-      if (! strcmp (alpha_tp_string, "p"))
+      if (! strcmp (GCC_OPTION (alpha_tp_string), "p"))
 	alpha_tp = ALPHA_TP_PROG;
-      else if (! strcmp (alpha_tp_string, "f"))
+      else if (! strcmp (GCC_OPTION (alpha_tp_string), "f"))
 	alpha_tp = ALPHA_TP_FUNC;
-      else if (! strcmp (alpha_tp_string, "i"))
+      else if (! strcmp (GCC_OPTION (alpha_tp_string), "i"))
 	alpha_tp = ALPHA_TP_INSN;
       else
-	error ("bad value %qs for -mtrap-precision switch", alpha_tp_string);
+	error ("bad value %qs for -mtrap-precision switch", GCC_OPTION (alpha_tp_string));
     }
 
-  if (alpha_fprm_string)
+  if (GCC_OPTION (alpha_fprm_string))
     {
-      if (! strcmp (alpha_fprm_string, "n"))
+      if (! strcmp (GCC_OPTION (alpha_fprm_string), "n"))
 	alpha_fprm = ALPHA_FPRM_NORM;
-      else if (! strcmp (alpha_fprm_string, "m"))
+      else if (! strcmp (GCC_OPTION (alpha_fprm_string), "m"))
 	alpha_fprm = ALPHA_FPRM_MINF;
-      else if (! strcmp (alpha_fprm_string, "c"))
+      else if (! strcmp (GCC_OPTION (alpha_fprm_string), "c"))
 	alpha_fprm = ALPHA_FPRM_CHOP;
-      else if (! strcmp (alpha_fprm_string,"d"))
+      else if (! strcmp (GCC_OPTION (alpha_fprm_string),"d"))
 	alpha_fprm = ALPHA_FPRM_DYN;
       else
 	error ("bad value %qs for -mfp-rounding-mode switch",
-	       alpha_fprm_string);
+	       GCC_OPTION (alpha_fprm_string));
     }
 
-  if (alpha_fptm_string)
+  if (GCC_OPTION (alpha_fptm_string))
     {
-      if (strcmp (alpha_fptm_string, "n") == 0)
+      if (strcmp (GCC_OPTION (alpha_fptm_string), "n") == 0)
 	alpha_fptm = ALPHA_FPTM_N;
-      else if (strcmp (alpha_fptm_string, "u") == 0)
+      else if (strcmp (GCC_OPTION (alpha_fptm_string), "u") == 0)
 	alpha_fptm = ALPHA_FPTM_U;
-      else if (strcmp (alpha_fptm_string, "su") == 0)
+      else if (strcmp (GCC_OPTION (alpha_fptm_string), "su") == 0)
 	alpha_fptm = ALPHA_FPTM_SU;
-      else if (strcmp (alpha_fptm_string, "sui") == 0)
+      else if (strcmp (GCC_OPTION (alpha_fptm_string), "sui") == 0)
 	alpha_fptm = ALPHA_FPTM_SUI;
       else
-	error ("bad value %qs for -mfp-trap-mode switch", alpha_fptm_string);
+	error ("bad value %qs for -mfp-trap-mode switch", GCC_OPTION (alpha_fptm_string));
     }
 
-  if (alpha_cpu_string)
+  if (GCC_OPTION (alpha_cpu_string))
     {
       for (i = 0; i < ct_size; i++)
-	if (! strcmp (alpha_cpu_string, cpu_table [i].name))
+	if (! strcmp (GCC_OPTION (alpha_cpu_string), cpu_table [i].name))
 	  {
 	    alpha_tune = alpha_cpu = cpu_table[i].processor;
 	    line_size = cpu_table[i].line_size;
 	    l1_size = cpu_table[i].l1_size;
 	    l2_size = cpu_table[i].l2_size;
-	    target_flags &= ~ (MASK_BWX | MASK_MAX | MASK_FIX | MASK_CIX);
-	    target_flags |= cpu_table[i].flags;
+	    GCC_OPTION (target_flags) &= ~ (MASK_BWX | MASK_MAX | MASK_FIX | MASK_CIX);
+	    GCC_OPTION (target_flags) |= cpu_table[i].flags;
 	    break;
 	  }
       if (i == ct_size)
-	error ("bad value %qs for -mcpu switch", alpha_cpu_string);
+	error ("bad value %qs for -mcpu switch", GCC_OPTION (alpha_cpu_string));
     }
 
-  if (alpha_tune_string)
+  if (GCC_OPTION (alpha_tune_string))
     {
       for (i = 0; i < ct_size; i++)
-	if (! strcmp (alpha_tune_string, cpu_table [i].name))
+	if (! strcmp (GCC_OPTION (alpha_tune_string), cpu_table [i].name))
 	  {
 	    alpha_tune = cpu_table[i].processor;
 	    line_size = cpu_table[i].line_size;
@@ -369,7 +369,7 @@ alpha_option_override (void)
 	    break;
 	  }
       if (i == ct_size)
-	error ("bad value %qs for -mtune switch", alpha_tune_string);
+	error ("bad value %qs for -mtune switch", GCC_OPTION (alpha_tune_string));
     }
 
   if (line_size)
@@ -416,22 +416,22 @@ alpha_option_override (void)
 	}
       if (target_flags_explicit & MASK_LONG_DOUBLE_128)
 	warning (0, "128-bit long double not supported for VAX floats");
-      target_flags &= ~MASK_LONG_DOUBLE_128;
+      GCC_OPTION (target_flags) &= ~MASK_LONG_DOUBLE_128;
     }
 
   {
     char *end;
     int lat;
 
-    if (!alpha_mlat_string)
-      alpha_mlat_string = "L1";
+    if (!GCC_OPTION (alpha_mlat_string))
+      GCC_OPTION (alpha_mlat_string) = "L1";
 
-    if (ISDIGIT ((unsigned char)alpha_mlat_string[0])
-	&& (lat = strtol (alpha_mlat_string, &end, 10), *end == '\0'))
+    if (ISDIGIT ((unsigned char)GCC_OPTION (alpha_mlat_string)[0])
+	&& (lat = strtol (GCC_OPTION (alpha_mlat_string), &end, 10), *end == '\0'))
       ;
-    else if ((alpha_mlat_string[0] == 'L' || alpha_mlat_string[0] == 'l')
-	     && ISDIGIT ((unsigned char)alpha_mlat_string[1])
-	     && alpha_mlat_string[2] == '\0')
+    else if ((GCC_OPTION (alpha_mlat_string)[0] == 'L' || GCC_OPTION (alpha_mlat_string)[0] == 'l')
+	     && ISDIGIT ((unsigned char)GCC_OPTION (alpha_mlat_string)[1])
+	     && GCC_OPTION (alpha_mlat_string)[2] == '\0')
       {
 	static int const cache_latency[][4] =
 	{
@@ -440,7 +440,7 @@ alpha_option_override (void)
 	  { 3, 12, 30 },	/* ev6 -- Bcache from DS20 LMbench.  */
 	};
 
-	lat = alpha_mlat_string[1] - '0';
+	lat = GCC_OPTION (alpha_mlat_string)[1] - '0';
 	if (lat <= 0 || lat > 3 || cache_latency[alpha_tune][lat-1] == -1)
 	  {
 	    warning (0, "L%d cache latency unknown for %s",
@@ -450,7 +450,7 @@ alpha_option_override (void)
 	else
 	  lat = cache_latency[alpha_tune][lat-1];
       }
-    else if (! strcmp (alpha_mlat_string, "main"))
+    else if (! strcmp (GCC_OPTION (alpha_mlat_string), "main"))
       {
 	/* Most current memories have about 370ns latency.  This is
 	   a reasonable guess for a fast cpu.  */
@@ -458,7 +458,7 @@ alpha_option_override (void)
       }
     else
       {
-	warning (0, "bad value %qs for -mmemory-latency", alpha_mlat_string);
+	warning (0, "bad value %qs for -mmemory-latency", GCC_OPTION (alpha_mlat_string));
 	lat = 3;
       }
 
@@ -467,25 +467,25 @@ alpha_option_override (void)
 
   /* Default the definition of "small data" to 8 bytes.  */
   if (!global_options_set.x_g_switch_value)
-    g_switch_value = 8;
+    GCC_OPTION (g_switch_value) = 8;
 
   /* Infer TARGET_SMALL_DATA from -fpic/-fPIC.  */
-  if (flag_pic == 1)
-    target_flags |= MASK_SMALL_DATA;
-  else if (flag_pic == 2)
-    target_flags &= ~MASK_SMALL_DATA;
+  if (GCC_OPTION (flag_pic) == 1)
+    GCC_OPTION (target_flags) |= MASK_SMALL_DATA;
+  else if (GCC_OPTION (flag_pic) == 2)
+    GCC_OPTION (target_flags) &= ~MASK_SMALL_DATA;
 
   /* Align labels and loops for optimal branching.  */
   /* ??? Kludge these by not doing anything if we don't optimize.  */
-  if (optimize > 0)
+  if (GCC_OPTION (optimize) > 0)
     {
-      if (align_loops <= 0)
-	align_loops = 16;
-      if (align_jumps <= 0)
-	align_jumps = 16;
+      if (GCC_OPTION (align_loops) <= 0)
+	GCC_OPTION (align_loops) = 16;
+      if (GCC_OPTION (align_jumps) <= 0)
+	GCC_OPTION (align_jumps) = 16;
     }
-  if (align_functions <= 0)
-    align_functions = 16;
+  if (GCC_OPTION (align_functions) <= 0)
+    GCC_OPTION (align_functions) = 16;
 
   /* Register variables and functions with the garbage collector.  */
 
@@ -502,7 +502,7 @@ alpha_option_override (void)
 
 #ifdef TARGET_DEFAULT_LONG_DOUBLE_128
   if (!(target_flags_explicit & MASK_LONG_DOUBLE_128))
-    target_flags |= MASK_LONG_DOUBLE_128;
+    GCC_OPTION (target_flags) |= MASK_LONG_DOUBLE_128;
 #endif
 }
 
@@ -691,7 +691,7 @@ alpha_in_small_data_p (const_tree exp)
 
       /* If this is an incomplete type with size 0, then we can't put it
 	 in sdata because it might be too big when completed.  */
-      if (size > 0 && size <= g_switch_value)
+      if (size > 0 && size <= GCC_OPTION (g_switch_value))
 	return true;
     }
 
@@ -1607,7 +1607,7 @@ alpha_emit_set_const_1 (rtx target, enum machine_mode mode,
   int i, bits;
   /* Use a pseudo if highly optimizing and still generating RTL.  */
   rtx subtarget
-    = (flag_expensive_optimizations && can_create_pseudo_p () ? 0 : target);
+    = (GCC_OPTION (flag_expensive_optimizations) && can_create_pseudo_p () ? 0 : target);
   rtx temp, insn;
 
   /* If this is a sign-extended 32-bit constant, we can do this in at most
@@ -2425,7 +2425,7 @@ alpha_emit_conditional_branch (rtx operands[], enum machine_mode cmp_mode)
 
   if (cmp_mode == DFmode)
     {
-      if (flag_unsafe_math_optimizations && cmp_code != UNORDERED)
+      if (GCC_OPTION (flag_unsafe_math_optimizations) && cmp_code != UNORDERED)
 	{
 	  /* When we are not as concerned about non-finite values, and we
 	     are comparing against zero, we can branch directly.  */
@@ -2604,7 +2604,7 @@ alpha_emit_conditional_move (rtx cmp, enum machine_mode mode)
   enum machine_mode cmp_mode
     = (GET_MODE (op0) == VOIDmode ? DImode : GET_MODE (op0));
   enum machine_mode cmov_mode = VOIDmode;
-  int local_fast_math = flag_unsafe_math_optimizations;
+  int local_fast_math = GCC_OPTION (flag_unsafe_math_optimizations);
   rtx tem;
 
   if (cmp_mode == TFmode)
@@ -6527,7 +6527,7 @@ alpha_add_builtins (const struct alpha_builtin_def *p, size_t count,
   size_t i;
 
   for (i = 0; i < count; ++i, ++p)
-    if ((target_flags & p->target_mask) == p->target_mask)
+    if ((GCC_OPTION (target_flags) & p->target_mask) == p->target_mask)
       alpha_builtin_function (p->name, ftype, p->code,
 			      (p->is_const ? ECF_CONST : 0) | ECF_NOTHROW);
 }
@@ -7608,7 +7608,7 @@ alpha_expand_prologue (void)
   sa_size = alpha_sa_size ();
   frame_size = compute_frame_size (get_frame_size (), sa_size);
 
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     current_function_static_stack_size = frame_size;
 
   if (TARGET_ABI_OPEN_VMS)
@@ -7643,7 +7643,7 @@ alpha_expand_prologue (void)
      Note that we are only allowed to adjust sp once in the prologue.  */
 
   probed_size = frame_size;
-  if (flag_stack_check)
+  if (GCC_OPTION (flag_stack_check))
     probed_size += STACK_CHECK_PROTECT;
 
   if (probed_size <= 32768)
@@ -7658,7 +7658,7 @@ alpha_expand_prologue (void)
 	  /* We only have to do this probe if we aren't saving registers or
 	     if we are probing beyond the frame because of -fstack-check.  */
 	  if ((sa_size == 0 && probed_size > probed - 4096)
-	      || flag_stack_check)
+	      || GCC_OPTION (flag_stack_check))
 	    emit_insn (gen_probe_stack (GEN_INT (-probed_size)));
 	}
 
@@ -7688,7 +7688,7 @@ alpha_expand_prologue (void)
 	 late in the compilation, generate the loop as a single insn.  */
       emit_insn (gen_prologue_stack_probe_loop (count, ptr));
 
-      if ((leftover > 4096 && sa_size == 0) || flag_stack_check)
+      if ((leftover > 4096 && sa_size == 0) || GCC_OPTION (flag_stack_check))
 	{
 	  rtx last = gen_rtx_MEM (DImode,
 				  plus_constant (Pmode, ptr, -leftover));
@@ -7696,7 +7696,7 @@ alpha_expand_prologue (void)
 	  emit_move_insn (last, const0_rtx);
 	}
 
-      if (flag_stack_check)
+      if (GCC_OPTION (flag_stack_check))
 	{
 	  /* If -fstack-check is specified we have to load the entire
 	     constant into a register and subtract from the sp in one go,
@@ -7893,7 +7893,7 @@ alpha_start_function (FILE *file, const char *fnname,
   alpha_sa_mask (&imask, &fmask);
 
   /* Issue function start and label.  */
-  if (TARGET_ABI_OPEN_VMS || !flag_inhibit_size_directive)
+  if (TARGET_ABI_OPEN_VMS || !GCC_OPTION (flag_inhibit_size_directive))
     {
       fputs ("\t.ent ", file);
       assemble_name (file, fnname);
@@ -7938,7 +7938,7 @@ alpha_start_function (FILE *file, const char *fnname,
 
   if (TARGET_ABI_OSF
       && TARGET_IEEE_CONFORMANT
-      && !flag_inhibit_size_directive)
+      && !GCC_OPTION (flag_inhibit_size_directive))
     {
       /* Set flags in procedure descriptor to request IEEE-conformant
 	 math-library routines.  The value we set it to is PDSC_EXC_IEEE
@@ -7959,7 +7959,7 @@ alpha_start_function (FILE *file, const char *fnname,
 	     vms_unwind_regno,
 	     frame_size >= (1UL << 31) ? 0 : frame_size,
 	     reg_offset);
-  else if (!flag_inhibit_size_directive)
+  else if (!GCC_OPTION (flag_inhibit_size_directive))
     fprintf (file, "\t.frame $%d," HOST_WIDE_INT_PRINT_DEC ",$26,%d\n",
 	     (frame_pointer_needed
 	      ? HARD_FRAME_POINTER_REGNUM : STACK_POINTER_REGNUM),
@@ -7978,7 +7978,7 @@ alpha_start_function (FILE *file, const char *fnname,
       if (alpha_procedure_type == PT_REGISTER)
 	fprintf (file, "\t.fp_save $%d\n", vms_save_fp_regno);
     }
-  else if (!flag_inhibit_size_directive)
+  else if (!GCC_OPTION (flag_inhibit_size_directive))
     {
       if (imask)
 	{
@@ -8026,7 +8026,7 @@ alpha_output_function_end_prologue (FILE *file)
 {
   if (TARGET_ABI_OPEN_VMS)
     fputs ("\t.prologue\n", file);
-  else if (!flag_inhibit_size_directive)
+  else if (!GCC_OPTION (flag_inhibit_size_directive))
     fprintf (file, "\t.prologue %d\n",
 	     alpha_function_needs_gp || cfun->is_thunk);
 }
@@ -8258,7 +8258,7 @@ alpha_end_function (FILE *file, const char *fnname, tree decl ATTRIBUTE_UNUSED)
 
   /* End the function.  */
   if (TARGET_ABI_OPEN_VMS
-      || !flag_inhibit_size_directive)
+      || !GCC_OPTION (flag_inhibit_size_directive))
     {
       fputs ("\t.end ", file);
       assemble_name (file, fnname);
@@ -8627,7 +8627,7 @@ alpha_handle_trap_shadows (void)
 	    }
 	  else if (alpha_tp == ALPHA_TP_INSN)
 	    {
-	      if (optimize > 0)
+	      if (GCC_OPTION (optimize) > 0)
 		{
 		  struct shadow_summary sum;
 
@@ -8704,7 +8704,7 @@ alpha_handle_trap_shadows (void)
 	  && GET_CODE (PATTERN (i)) != CLOBBER
 	  && get_attr_trap (i) == TRAP_YES)
 	{
-	  if (optimize && !trap_pending)
+	  if (GCC_OPTION (optimize) && !trap_pending)
 	    summarize_insn (PATTERN (i), &shadow, 0);
 	  trap_pending = 1;
 	}
@@ -9143,10 +9143,10 @@ alpha_align_insns (unsigned int max_align,
   /* Let shorten branches care for assigning alignments to code labels.  */
   shorten_branches (get_insns ());
 
-  if (align_functions < 4)
+  if (GCC_OPTION (align_functions) < 4)
     align = 4;
-  else if ((unsigned int) align_functions < max_align)
-    align = align_functions;
+  else if ((unsigned int) GCC_OPTION (align_functions) < max_align)
+    align = GCC_OPTION (align_functions);
   else
     align = max_align;
 
@@ -9349,15 +9349,15 @@ And in the noreturn case:
   if (current_function_has_exception_handlers ())
     alpha_pad_function_end ();
 
-  if (alpha_tp != ALPHA_TP_PROG || flag_exceptions)
+  if (alpha_tp != ALPHA_TP_PROG || GCC_OPTION (flag_exceptions))
     alpha_handle_trap_shadows ();
 
   /* Due to the number of extra trapb insns, don't bother fixing up
      alignment when trap precision is instruction.  Moreover, we can
      only do our job when sched2 is run.  */
-  if (optimize && !optimize_size
+  if (GCC_OPTION (optimize) && !GCC_OPTION (optimize_size)
       && alpha_tp != ALPHA_TP_INSN
-      && flag_schedule_insns_after_reload)
+      && GCC_OPTION (flag_schedule_insns_after_reload))
     {
       if (alpha_tune == PROCESSOR_EV4)
 	alpha_align_insns (8, alphaev4_next_group, alphaev4_next_nop);
@@ -9402,7 +9402,7 @@ alpha_file_start (void)
 static int
 alpha_elf_reloc_rw_mask (void)
 {
-  return flag_pic ? 3 : 2;
+  return GCC_OPTION (flag_pic) ? 3 : 2;
 }
 
 /* Return a section for X.  The only special thing we do here is to
@@ -9412,7 +9412,7 @@ static section *
 alpha_elf_select_rtx_section (enum machine_mode mode, rtx x,
 			      unsigned HOST_WIDE_INT align)
 {
-  if (TARGET_SMALL_DATA && GET_MODE_SIZE (mode) <= g_switch_value)
+  if (TARGET_SMALL_DATA && GET_MODE_SIZE (mode) <= GCC_OPTION (g_switch_value))
     /* ??? Consider using mergeable sdata sections.  */
     return sdata_section;
   else
diff --git a/gcc/config/alpha/alpha.h b/gcc/config/alpha/alpha.h
index 0ff793f..737411b 100644
--- a/gcc/config/alpha/alpha.h
+++ b/gcc/config/alpha/alpha.h
@@ -61,7 +61,7 @@ along with GCC; see the file COPYING3.  If not see
 	    builtin_define ("__alpha_ev4__");		\
 	    builtin_assert ("cpu=ev4");			\
 	  }						\
-	if (TARGET_IEEE || TARGET_IEEE_WITH_INEXACT)	\
+	if (GCC_OPTION (TARGET_IEEE) || TARGET_IEEE_WITH_INEXACT)	\
 	  builtin_define ("_IEEE_FP");			\
 	if (TARGET_IEEE_WITH_INEXACT)			\
 	  builtin_define ("_IEEE_FP_INEXACT");		\
diff --git a/gcc/config/alpha/elf.h b/gcc/config/alpha/elf.h
index 5a6803a..de477e5 100644
--- a/gcc/config/alpha/elf.h
+++ b/gcc/config/alpha/elf.h
@@ -45,12 +45,12 @@ along with GCC; see the file COPYING3.  If not see
 #undef  ASM_OUTPUT_ALIGNED_LOCAL
 #define ASM_OUTPUT_ALIGNED_LOCAL(FILE, NAME, SIZE, ALIGN)		\
 do {									\
-  if ((SIZE) <= (unsigned HOST_WIDE_INT) g_switch_value)		\
+  if ((SIZE) <= (unsigned HOST_WIDE_INT) GCC_OPTION (g_switch_value))		\
     switch_to_section (sbss_section);					\
   else									\
     switch_to_section (bss_section);					\
   ASM_OUTPUT_TYPE_DIRECTIVE (FILE, NAME, "object");			\
-  if (!flag_inhibit_size_directive)					\
+  if (!GCC_OPTION (flag_inhibit_size_directive))					\
     ASM_OUTPUT_SIZE_DIRECTIVE (FILE, NAME, SIZE);			\
   ASM_OUTPUT_ALIGN ((FILE), exact_log2((ALIGN) / BITS_PER_UNIT));	\
   ASM_OUTPUT_LABEL(FILE, NAME);						\
diff --git a/gcc/config/alpha/linux.h b/gcc/config/alpha/linux.h
index 966e9b2..abecca8 100644
--- a/gcc/config/alpha/linux.h
+++ b/gcc/config/alpha/linux.h
@@ -62,9 +62,9 @@ along with GCC; see the file COPYING3.  If not see
 #define OPTION_UCLIBC (DEFAULT_LIBC == LIBC_UCLIBC)
 #define OPTION_BIONIC (DEFAULT_LIBC == LIBC_BIONIC)
 #else
-#define OPTION_GLIBC  (linux_libc == LIBC_GLIBC)
-#define OPTION_UCLIBC (linux_libc == LIBC_UCLIBC)
-#define OPTION_BIONIC (linux_libc == LIBC_BIONIC)
+#define OPTION_GLIBC  (GCC_OPTION (linux_libc) == LIBC_GLIBC)
+#define OPTION_UCLIBC (GCC_OPTION (linux_libc) == LIBC_UCLIBC)
+#define OPTION_BIONIC (GCC_OPTION (linux_libc) == LIBC_BIONIC)
 #endif
 
 /* Determine what functions are present at the runtime;
